#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl

use strict;
use HTML::Template;
use PureMessage::Test::Pidfile;
use File::Basename;
use Data::Dump qw(dump);

our (%in,%text,@errors,@notifications);

require './pmx-test-lib.pl';

&header($text{'cancel_title'}, "", undef, 0, 1);

raise_error('error_missing_parameter', 'pidfile') unless $in{pidfile};

raise_error('error_invalid_parameter', 'pidfile') unless $in{pidfile} =~ /^([\w\.\-]+)\.pid$/;

#print html_escape(dump(%in));

unless (@errors) {
    eval {
        PureMessage::Test::Pidfile->new($in{pidfile})->killall();
    };
    
    if ($@) {
        raise_error('error_pidfile', html_escape($@));
    }  
    
    unlink $in{pidfile};
    
    my $basename = basename $in{pidfile}, '.pid';
    
    for (qw(.html .out)) {
        unlink $basename.$_;
    }
    push @notifications, "Test cancelled." unless @errors;
}

print "<p>", error_dlg_str(), "</p>" if @errors;

print "<p>", notification_str($_), "</p>"  for @notifications;

print "<a href='$in{from}' ><img border=0 src='/images/back.gif'></a>" if $in{from};

&footer("/", $text{'index'});
