#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl

use strict;
use HTML::Template;
use PureMessage::Manager::Config qw(%config);
use PureMessage::Version qw($PREFIX);
eval {use PureMessage::Test};
use PureMessage::Test::Messages;
use Data::Dump;

#print n2br(Data::Dump::dump(%in));

our %text;
our %in;

my $testn = 'filter';

# redirect STDERR
open STDERR, ">&STDOUT";

require './pmx-test-lib.pl';

our $params = {
    CHECKLIST => [
        {name => 'send_spam', label=>'Send spam messages', status => ''},
        {name => 'send_virus', label=>'Send virus messages', status => ''},
        {name => 'send_custom', label=>'Send custom messages', status => ''},                         
    ],
    PROGFILE => '',
    OUTFILE => '',
    TITLE => $text{"${testn}_title"},
    SHOW_REFRESH => 1,
    REFRESH => 1,
    URL => '',
    FOOTER => '',
    SCRIPT => 'filter.cgi',
};

sub make_show_progress {
	my $testheader = shift;
	
	my $func = sub {
		my $stats = shift;
		$params->{MSGSTATS} =  
		"<h3>$testheader</h3>".
		"Total".
		": $stats->{total}, ".
		"Accepted".
		": $stats->{ok}, ".
		"Spam (> 50%)".
		": $stats->{spam}, ".
		"Virus".
		": $stats->{virus}, ".
		"Time".
		": ".( $stats->{time}-$stats->{start} );
		update();
	};
	return $func;
}

# if this is the first access
if (not exists $in{'s_run_test.x'}) {
	# load form
	&header($text{"${testn}_title"}, "", undef, 0, 1);
	my $template = HTML::Template->new(filename => "tmpl/${testn}.html");
	$template->param(
	        sl_milter => get_tmpl_milters(),
		c_spam_msg => '',
		c_virus_msg => '',
		c_custom_msg => '',
		t_custom_msg_folder => "$PREFIX/etc/data/samples/spam",
		t_host => 'localhost',
		t_port => 25,
		t_to_user => 'puremessage-test@localhost',
		t_from_email => get_sender_addr(),
		SECTION_HEADER=>theme_section_header('Test Parameters'),
		SECTION_FOOTER=>theme_section_footer(["s_run_test", '-run', "Run", "Run Test"])
	  );
	print $template->output;  
	#print n2br(Data::Dump::dump(%in)."\n");
}
else {
    
    if (my $pid = fork_test()) {
        # parent: redirect and exit
        parent_finish($testn, $pid);
    }
    # child: run tests
    child_init($testn, $$);
    
    # actual tests start here
              
    my $SAMPLES_PATH = "$PREFIX/etc/data/samples";
    
    if ($in{c_spam_msg} =~ /on/) {
            set_status('send_spam','testing');
            update();
            unless (send_spam("", make_show_progress('Sending spam messages...') )) {
                    set_status('send_spam','failed');
                    cleanup();
            }
            set_status('send_spam','passed');
    } 
    else {
            set_status('send_spam','skipped');
    }
    
    if ($in{c_virus_msg} =~ /on/) {
            set_status('send_virus','testing');
            update();
            unless (send_virus("",make_show_progress('Sending virus messages...'))) {
                    set_status('send_virus','failed');
                    cleanup();
            }
            set_status('send_virus','passed');
    }
    else {
            set_status('send_virus','skipped');
    }
    
    if ($in{c_custom_msg} =~ /on/) {
            set_status('send_custom','testing');
            update();
            unless (send_custom($in{t_custom_msg_folder},make_show_progress('Sending custom messages...'))) {
                    set_status('send_custom','failed');
                    cleanup();			
            }
            set_status('send_custom','passed');
    }
    else {
            set_status('send_custom','skipped');
    }
    
    cleanup();
}
&footer("/", $text{'index'});

__END__
