#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
# index.cgi
use HTML::Template;
use File::Basename;
use PureMessage::Test::Pidfile;
require './pmx-test-lib.pl';

our $log_dir;
&header($text{'index_title'}, "", undef, 0, 1);


my $content = <<EOT;
<p>$text{index_content_heading_one}</p>
EOT

$content .= notification_str(<<EOT);
<p>
<dl>
<dt><a href="verify.cgi">$text{verify_title}</a></dt><dd>$text{verify_content}</dd>
<dt><a href="filter.cgi">$text{filter_title}</a></dt><dd>$text{filter_content}</dd>
</dl>
</p>
EOT

$content .= <<EOT;
<p>$text{index_content_heading_two}</p>
EOT

$content .= notification_str(<<EOT);
<p>
<dl>
<dt><a href="performance.cgi">$text{performance_title}</a></dt><dd>$text{performance_content}</dd>
<dt><a href="load.cgi">$text{load_title}</a></dt><dd>$text{load_content}</dd>
</dl>
</p>
EOT

$content .= '<p>'.&text('test_reports_content',$log_dir).'</p>';

$content .= get_live_tests();

print $content;

&footer("/", $text{'index'});

sub get_live_tests {
    my @live_tests = ();
    opendir DIR, '.';
    foreach (readdir(DIR)) {
        if (/^(\w+)-(\d+)-(\d+)\.pid$/) {
            my $pidfile = PureMessage::Test::Pidfile->new($_);
            # see if any processes in that file are running
            if (kill 0, $pidfile->pids) {
                my $basename = basename($_,'.pid');
                my ($tname,$pid,$time) = ($1,$2,$3);
                    push @live_tests,
                                        "<tr>".
                                        "<td class=light>".(text($tname.'_title') || $tname)."</td>".
                                        "<td class=light>$pid</td>".
                                        "<td class=light>".(scalar localtime $time)."</td>".
                                        "<td class=light><a href='cancel.cgi?pidfile=$basename.pid'>cancel</a>&nbsp;".
                                        "<a href='$basename.html'>view</a></td>".
                                        "</tr>";           
            }
            # else clean up the file
            else {
                unlink $_;
            }
 
        }
    }
    my $out_str = "";
    if (@live_tests) {
        $out_str .= "<p>The following tests are running:</p>";
        $out_str .= "<table cellspacing=1><tr><td class=dark>Test type</td><td class=dark>Process ID</td><td class=dark>Time Started</td><td class=dark>Action</td></tr>";
        $out_str .= $_ foreach @live_tests;
        $out_str .= "</table>";
    }
    return $out_str;
}
