#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl

use strict;
use HTML::Template;
use PureMessage::Manager::Config qw(%config);
use PureMessage::Version qw($PREFIX);
eval {use PureMessage::Test};
use PureMessage::Test::Messages;
use Data::Dump;

our %text;
our %in;
our @errors;

my $testn = 'load';

# redirect STDERR
open STDERR, ">&STDOUT";

require './pmx-test-lib.pl';

our $params = {
    STATUS => [
        {name => 'time', label=>'Time elapsed', value => ''},
        {name => 'nclients', label=>'Number of mail clients', value => ''},
        {name => 'nmessages', label=>'Messages processed', value => ''},
        {name => 'thruput', label=>'Throughput', value => ''},
    ],
    PROGFILE => '',
    OUTFILE => '',
    TITLE => $text{"${testn}_title"},
    SHOW_REFRESH => 1,
    REFRESH => 1,
    URL => '',
    FOOTER => '',
    SCRIPT => 'load.cgi',
};

my $form_params = {
    sl_milter => get_tmpl_milters(),
    t_num_clients => 15,
    t_load_inc_interval => 30,
    t_host => 'localhost',
    t_port => 25,
    t_to_user => 'puremessage-test@localhost',
    t_from_email => get_sender_addr(),
    SECTION_HEADER=>theme_section_header('Test Parameters'),
    SECTION_FOOTER=>theme_section_footer(["s_run_test", '-run', "Run", "Run Test"])
};

sub make_show_progress {
	my $func = sub {
		my $stats = shift;
		my $now = time;
		my $thruput;
		# average throughput
		$thruput = ($now - $stats->{start}) ? $stats->{total}/($now - $stats->{start}) * 60 : '0' ;
		set_value('time',($now-$stats->{start}).' seconds');
		set_value('nclients',$stats->{nclients});
		set_value('nmessages',$stats->{total});
		set_value('thruput',sprintf("%.2f messages/minute",$thruput));
		update();
	};
	return $func;
}

my $dont_test = 1;

if (exists $in{'s_run_test.x'}) {
    validate_integer($in{t_num_clients}, "Number of clients", min=>1);
    validate_integer($in{t_load_inc_interval}, "Load increase interval", min=>1);
    validate_integer($in{t_port}, "Sendmail port", min=>0);
    $dont_test = 0 if !@errors;
}

# if this is the first access
if ($dont_test) {
	# load form
	&header($text{"${testn}_title"}, "", undef, 0, 1);
	reload_text_inputs($form_params,
	            qw/t_num_clients t_load_inc_interval t_port t_host t_to_user t_from_email/);
        reload_select_inputs($form_params, qw/sl_milter/);
	my $template = HTML::Template->new(filename => "tmpl/${testn}.html");
	$template->param($form_params);
	print $template->output;  
	#print n2br(Data::Dump::dump(%in)."\n");
}
else {
    
    if (my $pid = fork_test()) {
        # parent: redirect and exit
        parent_finish($testn, $pid);
    }
    # child: run tests
    child_init($testn, $$);
    
    # actual tests start here
    my $stat_str = test_maxload(make_show_progress(),$in{t_num_clients},$in{t_load_inc_interval});
    $params->{FOOTER} = stat_dlg_str($stat_str);
    cleanup();
}
&footer("/", $text{'index'});

__END__
