#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
# index.cgi

use strict;
use HTML::Template;
use PureMessage::Manager::Config qw(%config);
use PureMessage::Version qw($PREFIX);
eval { use PureMessage::Test };
use PureMessage::Test::Messages;
use Data::Dump;

#print n2br(Data::Dump::dump(%in));

our %text;
our %in;

my $testn = 'verify';

# redirect STDERR
open STDERR, ">&STDOUT";

require './pmx-test-lib.pl';

our $params = {
    CHECKLIST => [
            {       
                name => 'test_start',
                label => 'Testing pmx-milter start',
                status => 'testing',
            },
            {
                name => 'test_stop',
                label => 'Testing pmx-milter stop',
                status => '',
            },
            {
                name => 'test_restart',
                label => 'Testing pmx-milter restart',
                status => '',
            },
            {
                name => 'test_status',
                label => 'Testing pmx-milter status',
                status => '',
            },
            {
                name => 'test_milter',
                label => 'Sending a test message directly to PureMessage milter',
                status => '',
            },
            {
                name => 'test_sendmail',
                label => 'Sending test message to Sendmail via SMTP',
                status => '',
            },
    ],
    PROGFILE => '',
    OUTFILE => '',
    TITLE => 'Verify PureMessage Setup',
    SHOW_REFRESH => 1,
    REFRESH => 1,
    URL => '',
    FOOTER => '',
    SCRIPT => 'verify.cgi',
};

# if this is the first access
if (not exists $in{'s_run_test.x'}) {
	# load form
	&header("$text{'verify_title'}", "", undef, 0, 1);
	my $template = HTML::Template->new(filename => 'tmpl/verify.html');
	$template->param(
                sl_milter => get_tmpl_milters(),
		c_stop_milter => '',
		t_host => 'localhost',
		t_port => 25,
		t_to_user => 'puremessage-test@localhost',
		t_from_email => get_sender_addr(),
		SECTION_HEADER=>theme_section_header('Test Parameters'),
                SECTION_FOOTER=>theme_section_footer(["s_run_test", '-run', "Run", "Run Test"])
	  );
	print $template->output;  
	#print n2br(Data::Dump::dump(%in)."\n");
}
else {
    
    if (my $pid = fork_test()) {
        # parent: redirect and exit
        parent_finish($testn, $pid);
    }
    # child: run tests
    child_init($testn, $$);
    
    use Config;
    $ENV{$Config{ldlibpthname}} = "$PREFIX/lib"; # for dynamic loading
    
    # Test PureMessage start/restart/status functionality
    set_status('test_start','testing');
    update();
    unless (test_start()) {
        set_status('test_start','failed');
        cleanup();
    }
    set_status('test_start','passed');
    
    if ($in{c_stop_milter} =~ /on/) {
        set_status('test_stop','testing');
        unless (test_stop()) {
            set_status('test_stop','failed');
            cleanup();
    }
        set_status('test_stop','passed');
        set_status('test_restart','testing');
        update();
    
        unless (test_start()) {
            set_status('test_restart','failed');
            update();
        }
        set_status('test_restart','passed');
        set_status('test_status','testing');
        update();
    } else {
        set_status('test_stop','skipped');
        set_status('test_restart','skipped');
        set_status('test_status','testing');
        update();
    }
    
    
    unless (test_status()) {
        set_status('test_status','failed');
        cleanup();
    }
    set_status('test_status','passed');
    set_status('test_milter','testing');
    update();
    
    unless (test_milter()) {
        set_status('test_milter','failed');
        cleanup();
    }  
    
    set_status('test_milter','passed');	
	
    unless ($in{c_test_sendmail} =~ /on/) {
            set_status('test_sendmail','skipped');
            cleanup();
    }
    
    set_status('test_sendmail','testing');
    update();
        
    unless (test_sendmail()) {
        set_status('test_sendmail','failed');
        cleanup();
    }
    
    set_status('test_sendmail','passed');
    cleanup();	
	
}
&footer("/", $text{'index'});
__END__
