package PureMessage::Test::Pidfile;

use strict;
use Carp qw(croak);

sub new {
    my $class = shift;
    my $filename = shift;
    croak "missing filename parameter" unless $filename;
    return (bless {pidfile=>$filename}, $class);
}

sub append {
    my $self = shift;
    my $pid = shift || $$;
    open (PID, ">>$self->{pidfile}") or croak "Could not write to file $self->{pidfile} $!";
    print PID "$pid\n";
    close PID;
}

sub pids {
    my $self = shift;
    open (PID, "$self->{pidfile}") or croak "Could not open $self->{pidfile} $!";
    my @pids = map {chomp;$_} <PID>;
    close PID;
    return @pids;
}

sub killall {
    my $self = shift;
    my $signal = shift;
    $signal = 9 unless defined $signal;
    my @pids = $self->pids;
    unlink($self->{pidfile});
    return (kill($signal, @pids) == scalar @pids);
}

1;
